%% ------  Lezione4, 24 ottobre 2016 ------ 
% Distribuzioni gaussiane,
% Classificazione bayesiana

clear all; % cancella il contenuto di memoria
close all; % cancella tutte le figure presenti nella sessione
clc; % pulisce lo schermo

%% Date due distribuzioni Gaussiane monodimensionali
% di parametri 
% mu1 = 4,
% mu2 = 0, 
% sigma1 = sigma2 = 1.5 
% 1. Genero due campionature significative

mu1 = 4;
sigma1 = 1.5;
mu2 = 0;
sigma2 = 1.5;

num_campioni1 = [1 1000];
num_campioni2 = [1 100];

x1 = normrnd(mu1,sigma1,num_campioni1);
x2 = normrnd(mu2,sigma2,num_campioni2);

labels = [ones(num_campioni1) 2*ones(num_campioni2)];

figure; hold on;
scatter(x1,zeros(num_campioni1),10,'b');
scatter(x2,zeros(num_campioni2),10,'r');
title('Generazione casuale di campioni da due gaussiane monodimensionali');

%% 2. Calcolo (e verificare) la media e la deviazione standard

est_mu1 = mean(x1)
est_sigma1 = std(x1)

est_mu2 = mean(x2)
est_sigma2 = std(x2)

%% 3. Valuto e visualizzo la likelihood di tutti i campioni

x = [x1 x2];

lik1 = normpdf(x,mu1,sigma1);
lik2 = normpdf(x,mu2,sigma2);

figure, hold on;
plot(x,lik1,'b.'), hold on, plot(x,lik2, 'r.')
title('Likelihood dei campioni sotto i due diversi modelli');
legend('classe 1', 'classe 2')

% Calcolo e visualizzo anche la log-likelihood
llik1 = log(lik1); 
llik2 = log(lik2); 
figure,
plot(x,llik1,'b.'), hold on, plot(x,llik2, 'r.')
title('Log Likelihood dei campioni');
legend('classe 1', 'classe 2')

%% ESERCIZIO
% Provare a classificare il dataset "iris_pca" seguendo
% le indicazioni contenute nelle slide.
load('iris_pca.mat')

% Estraggo i dati appartenenti alle 3 diverse classi separatamente
classe1 = data(:, labels==1);
classe2 = data(:, labels==2);
classe3 = data(:, labels==3);

% Stimo media e covarianza delle diverse classi
% Facendo così creo un MODELLO in grado di spiegare gli oggetti
% di una classe
m1 = mean(classe1, 2);
%NB Devo trasporre perché la matrice di covarianza deve risultare 2x2 (features x features)
c1 = cov(classe1'); 

m2 = mean(classe2, 2);
c2 = cov(classe2');


m3 = mean(classe3, 2);
c3 = cov(classe3');

% Valuto la likelihood di TUTTI i dati rispetto ai modelli,
% e assegno ogni oggetto alla classe con likelihood più alta
lik1 = mvnpdf(data', m1', c1);
lik2 = mvnpdf(data', m2', c2);
lik3 = mvnpdf(data', m3', c3);

likAll = [lik1 lik2 lik3];
% se prendo il max di ogni riga ho già l'etichetta di classe predetta
[val, predicted] = max(likAll, [], 2);

% Quante delle mie predizioni sono esatte?
% Confronto con il vettore di labels
accuratezza = sum(predicted'==labels);

% In percentuale:
accuratezza = accuratezza / length(labels);

fprintf('Accuratezza dei modelli: ');
accuratezza




